/* eslint-disable */
'use strict';

var path = require('path');
var pluginutils = require('@rollup/pluginutils');
var _ = require('lodash');
var require$$0$1 = require('util');
var require$$0 = require('os');
var resolve = require('resolve');
var fsExtra = require('fs-extra');
var fs = require('fs');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

function _interopNamespace(e) {
  if (e && e.__esModule) return e;
  var n = Object.create(null);
  if (e) {
    Object.keys(e).forEach(function (k) {
      if (k !== 'default') {
        var d = Object.getOwnPropertyDescriptor(e, k);
        Object.defineProperty(n, k, d.get ? d : {
          enumerable: true,
          get: function () { return e[k]; }
        });
      }
    });
  }
  n["default"] = e;
  return Object.freeze(n);
}

var path__namespace = /*#__PURE__*/_interopNamespace(path);
var ___namespace = /*#__PURE__*/_interopNamespace(_);
var require$$0__default$1 = /*#__PURE__*/_interopDefaultLegacy(require$$0$1);
var require$$0__default = /*#__PURE__*/_interopDefaultLegacy(require$$0);
var resolve__namespace = /*#__PURE__*/_interopNamespace(resolve);

var safe = {exports: {}};

var colors = {exports: {}};

var styles = {exports: {}};

/*
The MIT License (MIT)

Copyright (c) Sindre Sorhus <sindresorhus@gmail.com> (sindresorhus.com)

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

*/

(function (module) {
	var styles = {};
	module['exports'] = styles;

	var codes = {
	  reset: [0, 0],

	  bold: [1, 22],
	  dim: [2, 22],
	  italic: [3, 23],
	  underline: [4, 24],
	  inverse: [7, 27],
	  hidden: [8, 28],
	  strikethrough: [9, 29],

	  black: [30, 39],
	  red: [31, 39],
	  green: [32, 39],
	  yellow: [33, 39],
	  blue: [34, 39],
	  magenta: [35, 39],
	  cyan: [36, 39],
	  white: [37, 39],
	  gray: [90, 39],
	  grey: [90, 39],

	  brightRed: [91, 39],
	  brightGreen: [92, 39],
	  brightYellow: [93, 39],
	  brightBlue: [94, 39],
	  brightMagenta: [95, 39],
	  brightCyan: [96, 39],
	  brightWhite: [97, 39],

	  bgBlack: [40, 49],
	  bgRed: [41, 49],
	  bgGreen: [42, 49],
	  bgYellow: [43, 49],
	  bgBlue: [44, 49],
	  bgMagenta: [45, 49],
	  bgCyan: [46, 49],
	  bgWhite: [47, 49],
	  bgGray: [100, 49],
	  bgGrey: [100, 49],

	  bgBrightRed: [101, 49],
	  bgBrightGreen: [102, 49],
	  bgBrightYellow: [103, 49],
	  bgBrightBlue: [104, 49],
	  bgBrightMagenta: [105, 49],
	  bgBrightCyan: [106, 49],
	  bgBrightWhite: [107, 49],

	  // legacy styles for colors pre v1.0.0
	  blackBG: [40, 49],
	  redBG: [41, 49],
	  greenBG: [42, 49],
	  yellowBG: [43, 49],
	  blueBG: [44, 49],
	  magentaBG: [45, 49],
	  cyanBG: [46, 49],
	  whiteBG: [47, 49],

	};

	Object.keys(codes).forEach(function(key) {
	  var val = codes[key];
	  var style = styles[key] = [];
	  style.open = '\u001b[' + val[0] + 'm';
	  style.close = '\u001b[' + val[1] + 'm';
	});
} (styles));

/*
MIT License

Copyright (c) Sindre Sorhus <sindresorhus@gmail.com> (sindresorhus.com)

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in
the Software without restriction, including without limitation the rights to
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
of the Software, and to permit persons to whom the Software is furnished to do
so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/

var hasFlag$1 = function(flag, argv) {
  argv = argv || process.argv;

  var terminatorPos = argv.indexOf('--');
  var prefix = /^-{1,2}/.test(flag) ? '' : '--';
  var pos = argv.indexOf(prefix + flag);

  return pos !== -1 && (terminatorPos === -1 ? true : pos < terminatorPos);
};

/*
The MIT License (MIT)

Copyright (c) Sindre Sorhus <sindresorhus@gmail.com> (sindresorhus.com)

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

*/

var os = require$$0__default["default"];
var hasFlag = hasFlag$1;

var env = process.env;

var forceColor = void 0;
if (hasFlag('no-color') || hasFlag('no-colors') || hasFlag('color=false')) {
  forceColor = false;
} else if (hasFlag('color') || hasFlag('colors') || hasFlag('color=true')
           || hasFlag('color=always')) {
  forceColor = true;
}
if ('FORCE_COLOR' in env) {
  forceColor = env.FORCE_COLOR.length === 0
    || parseInt(env.FORCE_COLOR, 10) !== 0;
}

function translateLevel(level) {
  if (level === 0) {
    return false;
  }

  return {
    level: level,
    hasBasic: true,
    has256: level >= 2,
    has16m: level >= 3,
  };
}

function supportsColor(stream) {
  if (forceColor === false) {
    return 0;
  }

  if (hasFlag('color=16m') || hasFlag('color=full')
      || hasFlag('color=truecolor')) {
    return 3;
  }

  if (hasFlag('color=256')) {
    return 2;
  }

  if (stream && !stream.isTTY && forceColor !== true) {
    return 0;
  }

  var min = forceColor ? 1 : 0;

  if (process.platform === 'win32') {
    // Node.js 7.5.0 is the first version of Node.js to include a patch to
    // libuv that enables 256 color output on Windows. Anything earlier and it
    // won't work. However, here we target Node.js 8 at minimum as it is an LTS
    // release, and Node.js 7 is not. Windows 10 build 10586 is the first
    // Windows release that supports 256 colors. Windows 10 build 14931 is the
    // first release that supports 16m/TrueColor.
    var osRelease = os.release().split('.');
    if (Number(process.versions.node.split('.')[0]) >= 8
        && Number(osRelease[0]) >= 10 && Number(osRelease[2]) >= 10586) {
      return Number(osRelease[2]) >= 14931 ? 3 : 2;
    }

    return 1;
  }

  if ('CI' in env) {
    if (['TRAVIS', 'CIRCLECI', 'APPVEYOR', 'GITLAB_CI'].some(function(sign) {
      return sign in env;
    }) || env.CI_NAME === 'codeship') {
      return 1;
    }

    return min;
  }

  if ('TEAMCITY_VERSION' in env) {
    return (/^(9\.(0*[1-9]\d*)\.|\d{2,}\.)/.test(env.TEAMCITY_VERSION) ? 1 : 0
    );
  }

  if ('TERM_PROGRAM' in env) {
    var version = parseInt((env.TERM_PROGRAM_VERSION || '').split('.')[0], 10);

    switch (env.TERM_PROGRAM) {
      case 'iTerm.app':
        return version >= 3 ? 3 : 2;
      case 'Hyper':
        return 3;
      case 'Apple_Terminal':
        return 2;
      // No default
    }
  }

  if (/-256(color)?$/i.test(env.TERM)) {
    return 2;
  }

  if (/^screen|^xterm|^vt100|^rxvt|color|ansi|cygwin|linux/i.test(env.TERM)) {
    return 1;
  }

  if ('COLORTERM' in env) {
    return 1;
  }

  if (env.TERM === 'dumb') {
    return min;
  }

  return min;
}

function getSupportLevel(stream) {
  var level = supportsColor(stream);
  return translateLevel(level);
}

var supportsColors = {
  supportsColor: getSupportLevel,
  stdout: getSupportLevel(process.stdout),
  stderr: getSupportLevel(process.stderr),
};

var trap = {exports: {}};

var hasRequiredTrap;

function requireTrap () {
	if (hasRequiredTrap) return trap.exports;
	hasRequiredTrap = 1;
	(function (module) {
		module['exports'] = function runTheTrap(text, options) {
		  var result = '';
		  text = text || 'Run the trap, drop the bass';
		  text = text.split('');
		  var trap = {
		    a: ['\u0040', '\u0104', '\u023a', '\u0245', '\u0394', '\u039b', '\u0414'],
		    b: ['\u00df', '\u0181', '\u0243', '\u026e', '\u03b2', '\u0e3f'],
		    c: ['\u00a9', '\u023b', '\u03fe'],
		    d: ['\u00d0', '\u018a', '\u0500', '\u0501', '\u0502', '\u0503'],
		    e: ['\u00cb', '\u0115', '\u018e', '\u0258', '\u03a3', '\u03be', '\u04bc',
		      '\u0a6c'],
		    f: ['\u04fa'],
		    g: ['\u0262'],
		    h: ['\u0126', '\u0195', '\u04a2', '\u04ba', '\u04c7', '\u050a'],
		    i: ['\u0f0f'],
		    j: ['\u0134'],
		    k: ['\u0138', '\u04a0', '\u04c3', '\u051e'],
		    l: ['\u0139'],
		    m: ['\u028d', '\u04cd', '\u04ce', '\u0520', '\u0521', '\u0d69'],
		    n: ['\u00d1', '\u014b', '\u019d', '\u0376', '\u03a0', '\u048a'],
		    o: ['\u00d8', '\u00f5', '\u00f8', '\u01fe', '\u0298', '\u047a', '\u05dd',
		      '\u06dd', '\u0e4f'],
		    p: ['\u01f7', '\u048e'],
		    q: ['\u09cd'],
		    r: ['\u00ae', '\u01a6', '\u0210', '\u024c', '\u0280', '\u042f'],
		    s: ['\u00a7', '\u03de', '\u03df', '\u03e8'],
		    t: ['\u0141', '\u0166', '\u0373'],
		    u: ['\u01b1', '\u054d'],
		    v: ['\u05d8'],
		    w: ['\u0428', '\u0460', '\u047c', '\u0d70'],
		    x: ['\u04b2', '\u04fe', '\u04fc', '\u04fd'],
		    y: ['\u00a5', '\u04b0', '\u04cb'],
		    z: ['\u01b5', '\u0240'],
		  };
		  text.forEach(function(c) {
		    c = c.toLowerCase();
		    var chars = trap[c] || [' '];
		    var rand = Math.floor(Math.random() * chars.length);
		    if (typeof trap[c] !== 'undefined') {
		      result += trap[c][rand];
		    } else {
		      result += c;
		    }
		  });
		  return result;
		};
} (trap));
	return trap.exports;
}

var zalgo = {exports: {}};

var hasRequiredZalgo;

function requireZalgo () {
	if (hasRequiredZalgo) return zalgo.exports;
	hasRequiredZalgo = 1;
	(function (module) {
		// please no
		module['exports'] = function zalgo(text, options) {
		  text = text || '   he is here   ';
		  var soul = {
		    'up': [
		      '̍', '̎', '̄', '̅',
		      '̿', '̑', '̆', '̐',
		      '͒', '͗', '͑', '̇',
		      '̈', '̊', '͂', '̓',
		      '̈', '͊', '͋', '͌',
		      '̃', '̂', '̌', '͐',
		      '̀', '́', '̋', '̏',
		      '̒', '̓', '̔', '̽',
		      '̉', 'ͣ', 'ͤ', 'ͥ',
		      'ͦ', 'ͧ', 'ͨ', 'ͩ',
		      'ͪ', 'ͫ', 'ͬ', 'ͭ',
		      'ͮ', 'ͯ', '̾', '͛',
		      '͆', '̚',
		    ],
		    'down': [
		      '̖', '̗', '̘', '̙',
		      '̜', '̝', '̞', '̟',
		      '̠', '̤', '̥', '̦',
		      '̩', '̪', '̫', '̬',
		      '̭', '̮', '̯', '̰',
		      '̱', '̲', '̳', '̹',
		      '̺', '̻', '̼', 'ͅ',
		      '͇', '͈', '͉', '͍',
		      '͎', '͓', '͔', '͕',
		      '͖', '͙', '͚', '̣',
		    ],
		    'mid': [
		      '̕', '̛', '̀', '́',
		      '͘', '̡', '̢', '̧',
		      '̨', '̴', '̵', '̶',
		      '͜', '͝', '͞',
		      '͟', '͠', '͢', '̸',
		      '̷', '͡', ' ҉',
		    ],
		  };
		  var all = [].concat(soul.up, soul.down, soul.mid);

		  function randomNumber(range) {
		    var r = Math.floor(Math.random() * range);
		    return r;
		  }

		  function isChar(character) {
		    var bool = false;
		    all.filter(function(i) {
		      bool = (i === character);
		    });
		    return bool;
		  }


		  function heComes(text, options) {
		    var result = '';
		    var counts;
		    var l;
		    options = options || {};
		    options['up'] =
		      typeof options['up'] !== 'undefined' ? options['up'] : true;
		    options['mid'] =
		      typeof options['mid'] !== 'undefined' ? options['mid'] : true;
		    options['down'] =
		      typeof options['down'] !== 'undefined' ? options['down'] : true;
		    options['size'] =
		      typeof options['size'] !== 'undefined' ? options['size'] : 'maxi';
		    text = text.split('');
		    for (l in text) {
		      if (isChar(l)) {
		        continue;
		      }
		      result = result + text[l];
		      counts = {'up': 0, 'down': 0, 'mid': 0};
		      switch (options.size) {
		        case 'mini':
		          counts.up = randomNumber(8);
		          counts.mid = randomNumber(2);
		          counts.down = randomNumber(8);
		          break;
		        case 'maxi':
		          counts.up = randomNumber(16) + 3;
		          counts.mid = randomNumber(4) + 1;
		          counts.down = randomNumber(64) + 3;
		          break;
		        default:
		          counts.up = randomNumber(8) + 1;
		          counts.mid = randomNumber(6) / 2;
		          counts.down = randomNumber(8) + 1;
		          break;
		      }

		      var arr = ['up', 'mid', 'down'];
		      for (var d in arr) {
		        var index = arr[d];
		        for (var i = 0; i <= counts[index]; i++) {
		          if (options[index]) {
		            result = result + soul[index][randomNumber(soul[index].length)];
		          }
		        }
		      }
		    }
		    return result;
		  }
		  // don't summon him
		  return heComes(text, options);
		};
} (zalgo));
	return zalgo.exports;
}

var america = {exports: {}};

var hasRequiredAmerica;

function requireAmerica () {
	if (hasRequiredAmerica) return america.exports;
	hasRequiredAmerica = 1;
	(function (module) {
		module['exports'] = function(colors) {
		  return function(letter, i, exploded) {
		    if (letter === ' ') return letter;
		    switch (i%3) {
		      case 0: return colors.red(letter);
		      case 1: return colors.white(letter);
		      case 2: return colors.blue(letter);
		    }
		  };
		};
} (america));
	return america.exports;
}

var zebra = {exports: {}};

var hasRequiredZebra;

function requireZebra () {
	if (hasRequiredZebra) return zebra.exports;
	hasRequiredZebra = 1;
	(function (module) {
		module['exports'] = function(colors) {
		  return function(letter, i, exploded) {
		    return i % 2 === 0 ? letter : colors.inverse(letter);
		  };
		};
} (zebra));
	return zebra.exports;
}

var rainbow = {exports: {}};

var hasRequiredRainbow;

function requireRainbow () {
	if (hasRequiredRainbow) return rainbow.exports;
	hasRequiredRainbow = 1;
	(function (module) {
		module['exports'] = function(colors) {
		  // RoY G BiV
		  var rainbowColors = ['red', 'yellow', 'green', 'blue', 'magenta'];
		  return function(letter, i, exploded) {
		    if (letter === ' ') {
		      return letter;
		    } else {
		      return colors[rainbowColors[i++ % rainbowColors.length]](letter);
		    }
		  };
		};
} (rainbow));
	return rainbow.exports;
}

var random = {exports: {}};

var hasRequiredRandom;

function requireRandom () {
	if (hasRequiredRandom) return random.exports;
	hasRequiredRandom = 1;
	(function (module) {
		module['exports'] = function(colors) {
		  var available = ['underline', 'inverse', 'grey', 'yellow', 'red', 'green',
		    'blue', 'white', 'cyan', 'magenta', 'brightYellow', 'brightRed',
		    'brightGreen', 'brightBlue', 'brightWhite', 'brightCyan', 'brightMagenta'];
		  return function(letter, i, exploded) {
		    return letter === ' ' ? letter :
		      colors[
		          available[Math.round(Math.random() * (available.length - 2))]
		      ](letter);
		  };
		};
} (random));
	return random.exports;
}

/*

The MIT License (MIT)

Original Library
  - Copyright (c) Marak Squires

Additional functionality
 - Copyright (c) Sindre Sorhus <sindresorhus@gmail.com> (sindresorhus.com)

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

*/

(function (module) {
	var colors = {};
	module['exports'] = colors;

	colors.themes = {};

	var util = require$$0__default$1["default"];
	var ansiStyles = colors.styles = styles.exports;
	var defineProps = Object.defineProperties;
	var newLineRegex = new RegExp(/[\r\n]+/g);

	colors.supportsColor = supportsColors.supportsColor;

	if (typeof colors.enabled === 'undefined') {
	  colors.enabled = colors.supportsColor() !== false;
	}

	colors.enable = function() {
	  colors.enabled = true;
	};

	colors.disable = function() {
	  colors.enabled = false;
	};

	colors.stripColors = colors.strip = function(str) {
	  return ('' + str).replace(/\x1B\[\d+m/g, '');
	};

	// eslint-disable-next-line no-unused-vars
	colors.stylize = function stylize(str, style) {
	  if (!colors.enabled) {
	    return str+'';
	  }

	  var styleMap = ansiStyles[style];

	  // Stylize should work for non-ANSI styles, too
	  if(!styleMap && style in colors){
	    // Style maps like trap operate as functions on strings;
	    // they don't have properties like open or close.
	    return colors[style](str);
	  }

	  return styleMap.open + str + styleMap.close;
	};

	var matchOperatorsRe = /[|\\{}()[\]^$+*?.]/g;
	var escapeStringRegexp = function(str) {
	  if (typeof str !== 'string') {
	    throw new TypeError('Expected a string');
	  }
	  return str.replace(matchOperatorsRe, '\\$&');
	};

	function build(_styles) {
	  var builder = function builder() {
	    return applyStyle.apply(builder, arguments);
	  };
	  builder._styles = _styles;
	  // __proto__ is used because we must return a function, but there is
	  // no way to create a function with a different prototype.
	  builder.__proto__ = proto;
	  return builder;
	}

	var styles$1 = (function() {
	  var ret = {};
	  ansiStyles.grey = ansiStyles.gray;
	  Object.keys(ansiStyles).forEach(function(key) {
	    ansiStyles[key].closeRe =
	      new RegExp(escapeStringRegexp(ansiStyles[key].close), 'g');
	    ret[key] = {
	      get: function() {
	        return build(this._styles.concat(key));
	      },
	    };
	  });
	  return ret;
	})();

	var proto = defineProps(function colors() {}, styles$1);

	function applyStyle() {
	  var args = Array.prototype.slice.call(arguments);

	  var str = args.map(function(arg) {
	    // Use weak equality check so we can colorize null/undefined in safe mode
	    if (arg != null && arg.constructor === String) {
	      return arg;
	    } else {
	      return util.inspect(arg);
	    }
	  }).join(' ');

	  if (!colors.enabled || !str) {
	    return str;
	  }

	  var newLinesPresent = str.indexOf('\n') != -1;

	  var nestedStyles = this._styles;

	  var i = nestedStyles.length;
	  while (i--) {
	    var code = ansiStyles[nestedStyles[i]];
	    str = code.open + str.replace(code.closeRe, code.open) + code.close;
	    if (newLinesPresent) {
	      str = str.replace(newLineRegex, function(match) {
	        return code.close + match + code.open;
	      });
	    }
	  }

	  return str;
	}

	colors.setTheme = function(theme) {
	  if (typeof theme === 'string') {
	    console.log('colors.setTheme now only accepts an object, not a string.  ' +
	      'If you are trying to set a theme from a file, it is now your (the ' +
	      'caller\'s) responsibility to require the file.  The old syntax ' +
	      'looked like colors.setTheme(__dirname + ' +
	      '\'/../themes/generic-logging.js\'); The new syntax looks like '+
	      'colors.setTheme(require(__dirname + ' +
	      '\'/../themes/generic-logging.js\'));');
	    return;
	  }
	  for (var style in theme) {
	    (function(style) {
	      colors[style] = function(str) {
	        if (typeof theme[style] === 'object') {
	          var out = str;
	          for (var i in theme[style]) {
	            out = colors[theme[style][i]](out);
	          }
	          return out;
	        }
	        return colors[theme[style]](str);
	      };
	    })(style);
	  }
	};

	function init() {
	  var ret = {};
	  Object.keys(styles$1).forEach(function(name) {
	    ret[name] = {
	      get: function() {
	        return build([name]);
	      },
	    };
	  });
	  return ret;
	}

	var sequencer = function sequencer(map, str) {
	  var exploded = str.split('');
	  exploded = exploded.map(map);
	  return exploded.join('');
	};

	// custom formatter methods
	colors.trap = requireTrap();
	colors.zalgo = requireZalgo();

	// maps
	colors.maps = {};
	colors.maps.america = requireAmerica()(colors);
	colors.maps.zebra = requireZebra()(colors);
	colors.maps.rainbow = requireRainbow()(colors);
	colors.maps.random = requireRandom()(colors);

	for (var map in colors.maps) {
	  (function(map) {
	    colors[map] = function(str) {
	      return sequencer(colors.maps[map], str);
	    };
	  })(map);
	}

	defineProps(colors, init());
} (colors));

(function (module) {
	//
	// Remark: Requiring this file will use the "safe" colors API,
	// which will not touch String.prototype.
	//
	//   var colors = require('colors/safe');
	//   colors.red("foo")
	//
	//
	var colors$1 = colors.exports;
	module['exports'] = colors$1;
} (safe));

var VerbosityLevel;
(function (VerbosityLevel) {
    VerbosityLevel[VerbosityLevel["Error"] = 0] = "Error";
    VerbosityLevel[VerbosityLevel["Warning"] = 1] = "Warning";
    VerbosityLevel[VerbosityLevel["Info"] = 2] = "Info";
    VerbosityLevel[VerbosityLevel["Debug"] = 3] = "Debug";
})(VerbosityLevel || (VerbosityLevel = {}));
class ConsoleContext {
    constructor(verbosity, prefix = "") {
        this.verbosity = verbosity;
        this.prefix = prefix;
    }
    warn(message) {
        if (this.verbosity < VerbosityLevel.Warning)
            return;
        console.log(`${this.prefix}${___namespace.isFunction(message) ? message() : message}`);
    }
    error(message) {
        if (this.verbosity < VerbosityLevel.Error)
            return;
        console.log(`${this.prefix}${___namespace.isFunction(message) ? message() : message}`);
    }
    info(message) {
        if (this.verbosity < VerbosityLevel.Info)
            return;
        console.log(`${this.prefix}${___namespace.isFunction(message) ? message() : message}`);
    }
    debug(message) {
        if (this.verbosity < VerbosityLevel.Debug)
            return;
        console.log(`${this.prefix}${___namespace.isFunction(message) ? message() : message}`);
    }
}

class RollupContext {
    constructor(verbosity, bail, context, prefix = "") {
        this.verbosity = verbosity;
        this.bail = bail;
        this.context = context;
        this.prefix = prefix;
        this.hasContext = true;
        this.hasContext = ___namespace.isFunction(this.context.warn) && ___namespace.isFunction(this.context.error);
    }
    warn(message) {
        if (this.verbosity < VerbosityLevel.Warning)
            return;
        const text = ___namespace.isFunction(message) ? message() : message;
        if (this.hasContext)
            this.context.warn(`${text}`);
        else
            console.log(`${this.prefix}${text}`);
    }
    error(message) {
        if (this.verbosity < VerbosityLevel.Error)
            return;
        const text = ___namespace.isFunction(message) ? message() : message;
        if (this.hasContext) {
            if (this.bail)
                this.context.error(`${text}`);
            else
                this.context.warn(`${text}`);
        }
        else
            console.log(`${this.prefix}${text}`);
    }
    info(message) {
        if (this.verbosity < VerbosityLevel.Info)
            return;
        const text = ___namespace.isFunction(message) ? message() : message;
        console.log(`${this.prefix}${text}`);
    }
    debug(message) {
        if (this.verbosity < VerbosityLevel.Debug)
            return;
        const text = ___namespace.isFunction(message) ? message() : message;
        console.log(`${this.prefix}${text}`);
    }
}

let tsModule;
function setTypescriptModule(override) {
    tsModule = override;
}

class LanguageServiceHost {
    constructor(parsedConfig, transformers, cwd) {
        this.parsedConfig = parsedConfig;
        this.transformers = transformers;
        this.snapshots = {};
        this.versions = {};
        this.fileNames = new Set(parsedConfig.fileNames);
        this.cwd = cwd;
    }
    reset() {
        this.snapshots = {};
        this.versions = {};
    }
    setLanguageService(service) {
        this.service = service;
    }
    setSnapshot(fileName, data) {
        fileName = pluginutils.normalizePath(fileName);
        const snapshot = tsModule.ScriptSnapshot.fromString(data);
        this.snapshots[fileName] = snapshot;
        this.versions[fileName] = (this.versions[fileName] || 0) + 1;
        this.fileNames.add(fileName);
        return snapshot;
    }
    getScriptSnapshot(fileName) {
        fileName = pluginutils.normalizePath(fileName);
        if (fileName in this.snapshots)
            return this.snapshots[fileName];
        const source = tsModule.sys.readFile(fileName);
        if (source) {
            this.snapshots[fileName] = tsModule.ScriptSnapshot.fromString(source);
            this.versions[fileName] = (this.versions[fileName] || 0) + 1;
            return this.snapshots[fileName];
        }
        return undefined;
    }
    getCurrentDirectory() {
        return this.cwd;
    }
    getScriptVersion(fileName) {
        fileName = pluginutils.normalizePath(fileName);
        return (this.versions[fileName] || 0).toString();
    }
    getScriptFileNames() {
        return Array.from(this.fileNames.values());
    }
    getCompilationSettings() {
        return this.parsedConfig.options;
    }
    getDefaultLibFileName(opts) {
        return tsModule.getDefaultLibFilePath(opts);
    }
    useCaseSensitiveFileNames() {
        return tsModule.sys.useCaseSensitiveFileNames;
    }
    readDirectory(path, extensions, exclude, include) {
        return tsModule.sys.readDirectory(path, extensions, exclude, include);
    }
    readFile(path, encoding) {
        return tsModule.sys.readFile(path, encoding);
    }
    fileExists(path) {
        return tsModule.sys.fileExists(path);
    }
    realpath(path) {
        return tsModule.sys.realpath(path); // this exists in the default implementation: https://github.com/microsoft/TypeScript/blob/ab2523bbe0352d4486f67b73473d2143ad64d03d/src/compiler/sys.ts#L1288
    }
    getTypeRootsVersion() {
        return 0;
    }
    directoryExists(directoryName) {
        return tsModule.sys.directoryExists(directoryName);
    }
    getDirectories(directoryName) {
        return tsModule.sys.getDirectories(directoryName);
    }
    getCustomTransformers() {
        if (this.service === undefined || this.transformers === undefined || this.transformers.length === 0)
            return undefined;
        const transformer = {
            before: [],
            after: [],
            afterDeclarations: [],
        };
        for (const creator of this.transformers) {
            const factory = creator(this.service);
            if (factory.before)
                transformer.before = transformer.before.concat(factory.before);
            if (factory.after)
                transformer.after = transformer.after.concat(factory.after);
            if (factory.afterDeclarations)
                transformer.afterDeclarations = transformer.afterDeclarations.concat(factory.afterDeclarations);
        }
        return transformer;
    }
    trace(line) {
        console.log(line);
    }
}

/**
 * Saves data in new cache folder or reads it from old one.
 * Avoids perpetually growing cache and situations when things need to consider changed and then reverted data to be changed.
 */
class RollingCache {
    /**
     * @param cacheRoot: root folder for the cache
     * @param checkNewCache: whether to also look in new cache when reading from cache
     */
    constructor(cacheRoot, checkNewCache) {
        this.cacheRoot = cacheRoot;
        this.checkNewCache = checkNewCache;
        this.rolled = false;
        this.oldCacheRoot = `${this.cacheRoot}/cache`;
        this.newCacheRoot = `${this.cacheRoot}/cache_`;
        fsExtra.emptyDirSync(this.newCacheRoot);
    }
    /**
     * @returns true if name exist in old cache (or either old of new cache if checkNewCache is true)
     */
    exists(name) {
        if (this.rolled)
            return false;
        if (this.checkNewCache && fs.existsSync(`${this.newCacheRoot}/${name}`))
            return true;
        return fs.existsSync(`${this.oldCacheRoot}/${name}`);
    }
    path(name) {
        return `${this.oldCacheRoot}/${name}`;
    }
    /**
     * @returns true if old cache contains all names and nothing more
     */
    match(names) {
        if (this.rolled)
            return false;
        if (!fs.existsSync(this.oldCacheRoot))
            return names.length === 0; // empty folder matches
        return ___namespace.isEqual(fs.readdirSync(this.oldCacheRoot).sort(), names.sort());
    }
    /**
     * @returns data for name, must exist in old cache (or either old of new cache if checkNewCache is true)
     */
    read(name) {
        if (this.checkNewCache && fs.existsSync(`${this.newCacheRoot}/${name}`))
            return fsExtra.readJsonSync(`${this.newCacheRoot}/${name}`, { encoding: "utf8", throws: false });
        return fsExtra.readJsonSync(`${this.oldCacheRoot}/${name}`, { encoding: "utf8", throws: false });
    }
    write(name, data) {
        if (this.rolled)
            return;
        if (data === undefined)
            return;
        fsExtra.writeJsonSync(`${this.newCacheRoot}/${name}`, data);
    }
    touch(name) {
        if (this.rolled)
            return;
        fsExtra.ensureFileSync(`${this.newCacheRoot}/${name}`);
    }
    /**
     * clears old cache and moves new in its place
     */
    roll() {
        if (this.rolled)
            return;
        this.rolled = true;
        fsExtra.removeSync(this.oldCacheRoot);
        if (fs.existsSync(this.newCacheRoot)) {
            fs.renameSync(this.newCacheRoot, this.oldCacheRoot);
        }
    }
}

class FormatHost {
    getCurrentDirectory() {
        return tsModule.sys.getCurrentDirectory();
    }
    getCanonicalFileName(fileName) {
        return path__namespace.normalize(fileName);
    }
    getNewLine() {
        return tsModule.sys.newLine;
    }
}
const formatHost = new FormatHost();

class NoCache {
    exists(_name) {
        return false;
    }
    path(name) {
        return name;
    }
    match(_names) {
        return false;
    }
    read(_name) {
        return undefined;
    }
    write(_name, _data) {
        return;
    }
    touch(_name) {
        return;
    }
    roll() {
        return;
    }
}

const { Graph, alg } = require('graphlib');
const hash = require("object-hash");
function convertEmitOutput(output, references) {
    const out = { code: "", references };
    output.outputFiles.forEach((e) => {
        if (e.name.endsWith(".d.ts"))
            out.dts = e;
        else if (e.name.endsWith(".d.ts.map"))
            out.dtsmap = e;
        else if (e.name.endsWith(".map"))
            out.map = e.text;
        else
            out.code = e.text;
    });
    return out;
}
function getAllReferences(importer, snapshot, options) {
    if (!snapshot)
        return [];
    const info = tsModule.preProcessFile(snapshot.getText(0, snapshot.getLength()), true, true);
    return ___namespace.compact(info.referencedFiles.concat(info.importedFiles).map((reference) => {
        var _a;
        const resolved = tsModule.nodeModuleNameResolver(reference.fileName, importer, options, tsModule.sys);
        return (_a = resolved.resolvedModule) === null || _a === void 0 ? void 0 : _a.resolvedFileName;
    }));
}
function convertDiagnostic(type, data) {
    return data.map((diagnostic) => {
        const entry = {
            flatMessage: tsModule.flattenDiagnosticMessageText(diagnostic.messageText, "\n"),
            formatted: tsModule.formatDiagnosticsWithColorAndContext(data, formatHost),
            category: diagnostic.category,
            code: diagnostic.code,
            type,
        };
        if (diagnostic.file && diagnostic.start !== undefined) {
            const { line, character } = diagnostic.file.getLineAndCharacterOfPosition(diagnostic.start);
            entry.fileLine = `${diagnostic.file.fileName}(${line + 1},${character + 1})`;
        }
        return entry;
    });
}
class TsCache {
    constructor(noCache, hashIgnoreUnknown, host, cacheRoot, options, rollupConfig, rootFilenames, context) {
        this.noCache = noCache;
        this.host = host;
        this.cacheRoot = cacheRoot;
        this.options = options;
        this.rollupConfig = rollupConfig;
        this.context = context;
        this.cacheVersion = "9";
        this.cachePrefix = "rpt2_";
        this.ambientTypesDirty = false;
        this.hashOptions = { algorithm: "sha1", ignoreUnknown: false };
        this.hashOptions.ignoreUnknown = hashIgnoreUnknown;
        if (!noCache) {
            this.cacheDir = `${this.cacheRoot}/${this.cachePrefix}${hash({
                version: this.cacheVersion,
                rootFilenames,
                options: this.options,
                rollupConfig: this.rollupConfig,
                tsVersion: tsModule.version,
            }, 
            // @ts-ignore
            this.hashOptions)}`;
        }
        this.dependencyTree = new Graph({ directed: true });
        this.dependencyTree.setDefaultNodeLabel((_node) => ({ dirty: false }));
        const automaticTypes = tsModule.getAutomaticTypeDirectiveNames(options, tsModule.sys).map((entry) => tsModule.resolveTypeReferenceDirective(entry, undefined, options, tsModule.sys))
            .filter((entry) => entry.resolvedTypeReferenceDirective && entry.resolvedTypeReferenceDirective.resolvedFileName)
            .map((entry) => entry.resolvedTypeReferenceDirective.resolvedFileName);
        this.ambientTypes = rootFilenames.filter(file => file.endsWith(".d.ts"))
            .concat(automaticTypes)
            .map((id) => ({ id, snapshot: this.host.getScriptSnapshot(id) }));
        this.init();
        this.checkAmbientTypes();
    }
    clean() {
        if (fsExtra.pathExistsSync(this.cacheRoot)) {
            const entries = fsExtra.readdirSync(this.cacheRoot);
            entries.forEach((e) => {
                const dir = `${this.cacheRoot}/${e}`;
                if (e.startsWith(this.cachePrefix) && fsExtra.statSync(dir).isDirectory) {
                    this.context.info(safe.exports.blue(`cleaning cache: ${dir}`));
                    fsExtra.emptyDirSync(`${dir}`);
                    fsExtra.removeSync(`${dir}`);
                }
                else
                    this.context.debug(`not cleaning ${dir}`);
            });
        }
        this.init();
    }
    setDependency(importee, importer) {
        // importee -> importer
        this.context.debug(`${safe.exports.blue("dependency")} '${importee}'`);
        this.context.debug(`    imported by '${importer}'`);
        this.dependencyTree.setEdge(importer, importee);
    }
    walkTree(cb) {
        const acyclic = alg.isAcyclic(this.dependencyTree);
        if (acyclic) {
            // @ts-ignore
            alg.topsort(this.dependencyTree).forEach(id => cb(id));
            return;
        }
        this.context.info(safe.exports.yellow("import tree has cycles"));
        // @ts-ignore
        this.dependencyTree.nodes().forEach(id => cb(id));
    }
    done() {
        this.context.info(safe.exports.blue("rolling caches"));
        this.codeCache.roll();
        this.semanticDiagnosticsCache.roll();
        this.syntacticDiagnosticsCache.roll();
        this.typesCache.roll();
    }
    getCompiled(id, snapshot, transform) {
        if (this.noCache) {
            this.context.info(`${safe.exports.blue("transpiling")} '${id}'`);
            this.markAsDirty(id);
            return transform();
        }
        const name = this.makeName(id, snapshot);
        this.context.info(`${safe.exports.blue("transpiling")} '${id}'`);
        this.context.debug(`    cache: '${this.codeCache.path(name)}'`);
        if (this.codeCache.exists(name) && !this.isDirty(id, false)) {
            this.context.debug(safe.exports.green("    cache hit"));
            const data = this.codeCache.read(name);
            if (data) {
                this.codeCache.write(name, data);
                return data;
            }
            else
                this.context.warn(safe.exports.yellow("    cache broken, discarding"));
        }
        this.context.debug(safe.exports.yellow("    cache miss"));
        const transformedData = transform();
        this.codeCache.write(name, transformedData);
        this.markAsDirty(id);
        return transformedData;
    }
    getSyntacticDiagnostics(id, snapshot, check) {
        return this.getDiagnostics("syntax", this.syntacticDiagnosticsCache, id, snapshot, check);
    }
    getSemanticDiagnostics(id, snapshot, check) {
        return this.getDiagnostics("semantic", this.semanticDiagnosticsCache, id, snapshot, check);
    }
    checkAmbientTypes() {
        if (this.noCache) {
            this.ambientTypesDirty = true;
            return;
        }
        this.context.debug(safe.exports.blue("Ambient types:"));
        const typeNames = this.ambientTypes.filter((snapshot) => snapshot.snapshot !== undefined)
            .map((snapshot) => {
            this.context.debug(`    ${snapshot.id}`);
            return this.makeName(snapshot.id, snapshot.snapshot);
        });
        // types dirty if any d.ts changed, added or removed
        this.ambientTypesDirty = !this.typesCache.match(typeNames);
        if (this.ambientTypesDirty)
            this.context.info(safe.exports.yellow("ambient types changed, redoing all semantic diagnostics"));
        typeNames.forEach(this.typesCache.touch, this.typesCache);
    }
    getDiagnostics(type, cache, id, snapshot, check) {
        if (this.noCache) {
            this.markAsDirty(id);
            return convertDiagnostic(type, check());
        }
        const name = this.makeName(id, snapshot);
        this.context.debug(`    cache: '${cache.path(name)}'`);
        if (cache.exists(name) && !this.isDirty(id, true)) {
            this.context.debug(safe.exports.green("    cache hit"));
            const data = cache.read(name);
            if (data) {
                cache.write(name, data);
                return data;
            }
            else
                this.context.warn(safe.exports.yellow("    cache broken, discarding"));
        }
        this.context.debug(safe.exports.yellow("    cache miss"));
        const convertedData = convertDiagnostic(type, check());
        cache.write(name, convertedData);
        this.markAsDirty(id);
        return convertedData;
    }
    init() {
        if (this.noCache) {
            this.codeCache = new NoCache();
            this.typesCache = new NoCache();
            this.syntacticDiagnosticsCache = new NoCache();
            this.semanticDiagnosticsCache = new NoCache();
        }
        else {
            if (this.cacheDir === undefined)
                throw new Error(`this.cacheDir undefined`);
            this.codeCache = new RollingCache(`${this.cacheDir}/code`, true);
            this.typesCache = new RollingCache(`${this.cacheDir}/types`, true);
            this.syntacticDiagnosticsCache = new RollingCache(`${this.cacheDir}/syntacticDiagnostics`, true);
            this.semanticDiagnosticsCache = new RollingCache(`${this.cacheDir}/semanticDiagnostics`, true);
        }
    }
    markAsDirty(id) {
        this.dependencyTree.setNode(id, { dirty: true });
    }
    // returns true if node or any of its imports or any of global types changed
    isDirty(id, checkImports) {
        const label = this.dependencyTree.node(id);
        if (!label)
            return false;
        if (!checkImports || label.dirty)
            return label.dirty;
        if (this.ambientTypesDirty)
            return true;
        const dependencies = alg.dijkstra(this.dependencyTree, id);
        return Object.keys(dependencies).some(node => {
            const dependency = dependencies[node];
            if (!node || dependency.distance === Infinity)
                return false;
            const l = this.dependencyTree.node(node);
            const dirty = l === undefined ? true : l.dirty;
            if (dirty)
                this.context.debug(`    import changed: ${node}`);
            return dirty;
        });
    }
    makeName(id, snapshot) {
        const data = snapshot.getText(0, snapshot.getLength());
        // @ts-ignore
        return hash({ data, id }, this.hashOptions);
    }
}

function printDiagnostics(context, diagnostics, pretty) {
    diagnostics.forEach((diagnostic) => {
        let print;
        let color;
        let category;
        switch (diagnostic.category) {
            case tsModule.DiagnosticCategory.Message:
                print = context.info;
                color = safe.exports.white;
                category = "";
                break;
            case tsModule.DiagnosticCategory.Error:
                print = context.error;
                color = safe.exports.red;
                category = "error";
                break;
            case tsModule.DiagnosticCategory.Warning:
            default:
                print = context.warn;
                color = safe.exports.yellow;
                category = "warning";
                break;
        }
        const type = diagnostic.type + " ";
        if (pretty)
            print.call(context, `${diagnostic.formatted}`);
        else {
            if (diagnostic.fileLine !== undefined)
                print.call(context, `${diagnostic.fileLine}: ${type}${category} TS${diagnostic.code}: ${color(diagnostic.flatMessage)}`);
            else
                print.call(context, `${type}${category} TS${diagnostic.code}: ${color(diagnostic.flatMessage)}`);
        }
    });
}

function getOptionsOverrides({ useTsconfigDeclarationDir, cacheRoot }, preParsedTsconfig) {
    const overrides = {
        noEmitHelpers: false,
        importHelpers: true,
        noResolve: false,
        noEmit: false,
        noEmitOnError: false,
        inlineSourceMap: false,
        outDir: pluginutils.normalizePath(`${cacheRoot}/placeholder`),
        moduleResolution: tsModule.ModuleResolutionKind.NodeJs,
        allowNonTsExtensions: true,
    };
    if (preParsedTsconfig) {
        if (preParsedTsconfig.options.module === undefined)
            overrides.module = tsModule.ModuleKind.ES2015;
        // only set declarationDir if useTsconfigDeclarationDir is enabled
        if (!useTsconfigDeclarationDir)
            overrides.declarationDir = undefined;
        // unsetting sourceRoot if sourceMap is not enabled (in case original tsconfig had inlineSourceMap set that is being unset and would cause TS5051)
        const sourceMap = preParsedTsconfig.options.sourceMap;
        if (!sourceMap)
            overrides.sourceRoot = undefined;
    }
    return overrides;
}
function expandIncludeWithDirs(include, dirs) {
    const newDirs = [];
    dirs.forEach(root => {
        if (include instanceof Array)
            include.forEach(x => newDirs.push(pluginutils.normalizePath(path__namespace.join(root, x))));
        else
            newDirs.push(pluginutils.normalizePath(path__namespace.join(root, include)));
    });
    return newDirs;
}
function createFilter(context, pluginOptions, parsedConfig) {
    let included = pluginOptions.include;
    let excluded = pluginOptions.exclude;
    if (parsedConfig.options.rootDirs) {
        included = expandIncludeWithDirs(included, parsedConfig.options.rootDirs);
        excluded = expandIncludeWithDirs(excluded, parsedConfig.options.rootDirs);
    }
    if (parsedConfig.projectReferences) {
        included = expandIncludeWithDirs(included, parsedConfig.projectReferences.map((x) => x.path)).concat(included);
        excluded = expandIncludeWithDirs(excluded, parsedConfig.projectReferences.map((x) => x.path)).concat(excluded);
    }
    context.debug(() => `included:\n${JSON.stringify(included, undefined, 4)}`);
    context.debug(() => `excluded:\n${JSON.stringify(excluded, undefined, 4)}`);
    return pluginutils.createFilter(included, excluded, { resolve: parsedConfig.options.rootDir });
}

function checkTsConfig(parsedConfig) {
    const module = parsedConfig.options.module;
    if (module !== tsModule.ModuleKind.ES2015 && module !== tsModule.ModuleKind.ESNext && module !== tsModule.ModuleKind.ES2020)
        throw new Error(`Incompatible tsconfig option. Module resolves to '${tsModule.ModuleKind[module]}'. This is incompatible with rollup, please use 'module: "ES2015"' or 'module: "ESNext"'.`);
}

function parseTsConfig(context, pluginOptions) {
    var _a, _b;
    const fileName = tsModule.findConfigFile(pluginOptions.cwd, tsModule.sys.fileExists, pluginOptions.tsconfig);
    // if the value was provided, but no file, fail hard
    if (pluginOptions.tsconfig !== undefined && !fileName)
        throw new Error(`rpt2: failed to open '${fileName}'`);
    let loadedConfig = {};
    let baseDir = pluginOptions.cwd;
    let configFileName;
    let pretty = false;
    if (fileName) {
        const text = tsModule.sys.readFile(fileName);
        if (text === undefined)
            throw new Error(`rpt2: failed to read '${fileName}'`);
        const result = tsModule.parseConfigFileTextToJson(fileName, text);
        pretty = (_b = (_a = result.config) === null || _a === void 0 ? void 0 : _a.pretty) !== null && _b !== void 0 ? _b : pretty;
        if (result.error !== undefined) {
            printDiagnostics(context, convertDiagnostic("config", [result.error]), pretty);
            throw new Error(`rpt2: failed to parse '${fileName}'`);
        }
        loadedConfig = result.config;
        baseDir = path.dirname(fileName);
        configFileName = fileName;
    }
    const mergedConfig = {};
    ___namespace.merge(mergedConfig, pluginOptions.tsconfigDefaults, loadedConfig, pluginOptions.tsconfigOverride);
    const preParsedTsConfig = tsModule.parseJsonConfigFileContent(mergedConfig, tsModule.sys, baseDir, getOptionsOverrides(pluginOptions), configFileName);
    const compilerOptionsOverride = getOptionsOverrides(pluginOptions, preParsedTsConfig);
    const parsedTsConfig = tsModule.parseJsonConfigFileContent(mergedConfig, tsModule.sys, baseDir, compilerOptionsOverride, configFileName);
    checkTsConfig(parsedTsConfig);
    printDiagnostics(context, convertDiagnostic("config", parsedTsConfig.errors), pretty);
    context.debug(`built-in options overrides: ${JSON.stringify(compilerOptionsOverride, undefined, 4)}`);
    context.debug(`parsed tsconfig: ${JSON.stringify(parsedTsConfig, undefined, 4)}`);
    return { parsedTsConfig, fileName };
}

// The injected id for helpers.
const TSLIB = "tslib";
const TSLIB_VIRTUAL = "\0tslib.js";
let tslibSource;
let tslibVersion;
try {
    // tslint:disable-next-line:no-string-literal no-var-requires
    const tslibPackage = require("tslib/package.json");
    const tslibPath = require.resolve("tslib/" + tslibPackage.module);
    tslibSource = fs.readFileSync(tslibPath, "utf8");
    tslibVersion = tslibPackage.version;
}
catch (e) {
    console.warn("Error loading `tslib` helper library.");
    throw e;
}

const findCacheDir = require("find-cache-dir");
const typescript = (options) => {
    let watchMode = false;
    let generateRound = 0;
    let rollupOptions;
    let context;
    let filter;
    let parsedConfig;
    let tsConfigPath;
    let servicesHost;
    let service;
    let noErrors = true;
    const declarations = {};
    const allImportedFiles = new Set();
    let _cache;
    const cache = () => {
        if (!_cache)
            _cache = new TsCache(pluginOptions.clean, pluginOptions.objectHashIgnoreUnknownHack, servicesHost, pluginOptions.cacheRoot, parsedConfig.options, rollupOptions, parsedConfig.fileNames, context);
        return _cache;
    };
    const getDiagnostics = (id, snapshot) => {
        return cache().getSyntacticDiagnostics(id, snapshot, () => {
            return service.getSyntacticDiagnostics(id);
        }).concat(cache().getSemanticDiagnostics(id, snapshot, () => {
            return service.getSemanticDiagnostics(id);
        }));
    };
    const pluginOptions = Object.assign({}, {
        check: true,
        verbosity: VerbosityLevel.Warning,
        clean: false,
        cacheRoot: findCacheDir({ name: "rollup-plugin-typescript2" }),
        include: ["*.ts+(|x)", "**/*.ts+(|x)"],
        exclude: ["*.d.ts", "**/*.d.ts"],
        abortOnError: true,
        rollupCommonJSResolveHack: false,
        tsconfig: undefined,
        useTsconfigDeclarationDir: false,
        tsconfigOverride: {},
        transformers: [],
        tsconfigDefaults: {},
        objectHashIgnoreUnknownHack: false,
        cwd: process.cwd(),
    }, options);
    if (!pluginOptions.typescript) {
        pluginOptions.typescript = require("typescript");
    }
    setTypescriptModule(pluginOptions.typescript);
    const self = {
        name: "rpt2",
        options(config) {
            rollupOptions = Object.assign({}, config);
            context = new ConsoleContext(pluginOptions.verbosity, "rpt2: ");
            watchMode = process.env.ROLLUP_WATCH === "true";
            ({ parsedTsConfig: parsedConfig, fileName: tsConfigPath } = parseTsConfig(context, pluginOptions));
            if (generateRound === 0) {
                parsedConfig.fileNames.map(allImportedFiles.add, allImportedFiles);
                context.info(`typescript version: ${tsModule.version}`);
                context.info(`tslib version: ${tslibVersion}`);
                if (this.meta)
                    context.info(`rollup version: ${this.meta.rollupVersion}`);
                context.info(`rollup-plugin-typescript2 version: $RPT2_VERSION`);
                context.debug(() => `plugin options:\n${JSON.stringify(pluginOptions, (key, value) => key === "typescript" ? `version ${value.version}` : value, 4)}`);
                context.debug(() => `rollup config:\n${JSON.stringify(rollupOptions, undefined, 4)}`);
                context.debug(() => `tsconfig path: ${tsConfigPath}`);
                if (pluginOptions.objectHashIgnoreUnknownHack)
                    context.warn(() => `${safe.exports.yellow("You are using 'objectHashIgnoreUnknownHack' option")}. If you enabled it because of async functions, try disabling it now.`);
                if (watchMode)
                    context.info(`running in watch mode`);
            }
            filter = createFilter(context, pluginOptions, parsedConfig);
            servicesHost = new LanguageServiceHost(parsedConfig, pluginOptions.transformers, pluginOptions.cwd);
            service = tsModule.createLanguageService(servicesHost, tsModule.createDocumentRegistry());
            servicesHost.setLanguageService(service);
            // printing compiler option errors
            if (pluginOptions.check)
                printDiagnostics(context, convertDiagnostic("options", service.getCompilerOptionsDiagnostics()), parsedConfig.options.pretty === true);
            if (pluginOptions.clean)
                cache().clean();
            return config;
        },
        watchChange(id) {
            const key = pluginutils.normalizePath(id);
            delete declarations[key];
        },
        resolveId(importee, importer) {
            var _a;
            if (importee === TSLIB)
                return TSLIB_VIRTUAL;
            if (!importer)
                return;
            importer = pluginutils.normalizePath(importer);
            // avoiding trying to resolve ids for things imported from files unrelated to this plugin
            if (!allImportedFiles.has(importer))
                return;
            // TODO: use module resolution cache
            const result = tsModule.nodeModuleNameResolver(importee, importer, parsedConfig.options, tsModule.sys);
            let resolved = (_a = result.resolvedModule) === null || _a === void 0 ? void 0 : _a.resolvedFileName;
            if (!resolved)
                return;
            if (filter(resolved))
                cache().setDependency(resolved, importer);
            if (resolved.endsWith(".d.ts"))
                return;
            if (pluginOptions.rollupCommonJSResolveHack)
                resolved = resolve__namespace.sync(resolved);
            context.debug(() => `${safe.exports.blue("resolving")} '${importee}' imported by '${importer}'`);
            context.debug(() => `    to '${resolved}'`);
            return path.normalize(resolved); // use host OS separators to fix Windows issue: https://github.com/ezolenko/rollup-plugin-typescript2/pull/251
        },
        load(id) {
            if (id === TSLIB_VIRTUAL)
                return tslibSource;
            return null;
        },
        transform(code, id) {
            generateRound = 0; // in watch mode transform call resets generate count (used to avoid printing too many copies of the same error messages)
            if (!filter(id))
                return undefined;
            allImportedFiles.add(pluginutils.normalizePath(id));
            const contextWrapper = new RollupContext(pluginOptions.verbosity, pluginOptions.abortOnError, this, "rpt2: ");
            const snapshot = servicesHost.setSnapshot(id, code);
            // getting compiled file from cache or from ts
            const result = cache().getCompiled(id, snapshot, () => {
                const output = service.getEmitOutput(id);
                if (output.emitSkipped) {
                    noErrors = false;
                    // always checking on fatal errors, even if options.check is set to false
                    const diagnostics = getDiagnostics(id, snapshot);
                    printDiagnostics(contextWrapper, diagnostics, parsedConfig.options.pretty === true);
                    // since no output was generated, aborting compilation
                    cache().done();
                    if (___namespace.isFunction(this.error))
                        this.error(safe.exports.red(`failed to transpile '${id}'`));
                }
                const references = getAllReferences(id, servicesHost.getScriptSnapshot(id), parsedConfig.options);
                return convertEmitOutput(output, references);
            });
            if (pluginOptions.check) {
                const diagnostics = getDiagnostics(id, snapshot);
                if (diagnostics.length > 0)
                    noErrors = false;
                printDiagnostics(contextWrapper, diagnostics, parsedConfig.options.pretty === true);
            }
            if (!result)
                return undefined;
            if (result.references)
                result.references.map(pluginutils.normalizePath).map(allImportedFiles.add, allImportedFiles);
            if (watchMode && this.addWatchFile && result.references) {
                if (tsConfigPath)
                    this.addWatchFile(tsConfigPath);
                result.references.map(this.addWatchFile, this);
                context.debug(() => `${safe.exports.green("    watching")}: ${result.references.join("\nrpt2:               ")}`);
            }
            if (result.dts) {
                const key = pluginutils.normalizePath(id);
                declarations[key] = { type: result.dts, map: result.dtsmap };
                context.debug(() => `${safe.exports.blue("generated declarations")} for '${key}'`);
            }
            const transformResult = { code: result.code, map: { mappings: "" } };
            if (result.map) {
                if (pluginOptions.sourceMapCallback)
                    pluginOptions.sourceMapCallback(id, result.map);
                transformResult.map = JSON.parse(result.map);
            }
            return transformResult;
        },
        generateBundle(bundleOptions) {
            self._ongenerate();
            self._onwrite.call(this, bundleOptions);
        },
        _ongenerate() {
            context.debug(() => `generating target ${generateRound + 1}`);
            if (pluginOptions.check && watchMode && generateRound === 0) {
                cache().walkTree((id) => {
                    if (!filter(id))
                        return;
                    const snapshot = servicesHost.getScriptSnapshot(id);
                    if (!snapshot)
                        return;
                    const diagnostics = getDiagnostics(id, snapshot);
                    printDiagnostics(context, diagnostics, parsedConfig.options.pretty === true);
                });
            }
            if (!watchMode && !noErrors)
                context.info(safe.exports.yellow("there were errors or warnings."));
            cache().done();
            generateRound++;
        },
        _onwrite(_output) {
            if (!parsedConfig.options.declaration)
                return;
            parsedConfig.fileNames.forEach((name) => {
                const key = pluginutils.normalizePath(name);
                if (key in declarations)
                    return;
                if (!allImportedFiles.has(key)) {
                    context.debug(() => `skipping declarations for unused '${key}'`);
                    return;
                }
                context.debug(() => `generating missed declarations for '${key}'`);
                const output = service.getEmitOutput(key, true);
                const out = convertEmitOutput(output);
                if (out.dts)
                    declarations[key] = { type: out.dts, map: out.dtsmap };
            });
            const emitDeclaration = (key, extension, entry) => {
                if (!entry)
                    return;
                let fileName = entry.name;
                if (fileName.includes("?")) // HACK for rollup-plugin-vue, it creates virtual modules in form 'file.vue?rollup-plugin-vue=script.ts'
                    fileName = fileName.split(".vue?", 1) + extension;
                // If 'useTsconfigDeclarationDir' is in plugin options, directly write to 'declarationDir'.
                // This may not be under Rollup's output directory, and thus can't be emitted as an asset.
                if (pluginOptions.useTsconfigDeclarationDir) {
                    context.debug(() => `${safe.exports.blue("emitting declarations")} for '${key}' to '${fileName}'`);
                    tsModule.sys.writeFile(fileName, entry.text, entry.writeByteOrderMark);
                    return;
                }
                // don't mutate the entry because generateBundle gets called multiple times
                let entryText = entry.text;
                const cachePlaceholder = `${pluginOptions.cacheRoot}/placeholder`;
                // modify declaration map sources to correct relative path (only if outputting)
                if (extension === ".d.ts.map" && ((_output === null || _output === void 0 ? void 0 : _output.file) || (_output === null || _output === void 0 ? void 0 : _output.dir))) {
                    const declarationDir = (_output.file ? path.dirname(_output.file) : _output.dir);
                    const parsedText = JSON.parse(entryText);
                    // invert back to absolute, then make relative to declarationDir
                    parsedText.sources = parsedText.sources.map(source => {
                        const absolutePath = path.resolve(cachePlaceholder, source);
                        return pluginutils.normalizePath(path.relative(declarationDir, absolutePath));
                    });
                    entryText = JSON.stringify(parsedText);
                }
                const relativePath = pluginutils.normalizePath(path.relative(cachePlaceholder, fileName));
                context.debug(() => `${safe.exports.blue("emitting declarations")} for '${key}' to '${relativePath}'`);
                this.emitFile({
                    type: "asset",
                    source: entryText,
                    fileName: relativePath,
                });
            };
            Object.keys(declarations).forEach((key) => {
                const { type, map } = declarations[key];
                emitDeclaration(key, ".d.ts", type);
                emitDeclaration(key, ".d.ts.map", map);
            });
        },
    };
    return self;
};

module.exports = typescript;
//# sourceMappingURL=rollup-plugin-typescript2.cjs.js.map
